<html>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<!--
*  Copyright © 1997, 2011, Oracle and/or its affiliates. All rights reserved.
*  Use is subject to license terms.
-->
<head>
<meta http-equiv="content-type" content="text/html; charset=UTF-8">
<title>About MIDP Projects</title>
<link rel="StyleSheet" href="nbdocs:/org/netbeans/modules/usersguide/ide.css" type="text/css">
</head>
<body>
<h2>About MIDP Projects</h2>
<p>A project is a group of source files and the settings with which you build, 
  run, and debug those source files. In the IDE, all Java development has to take 
  place within a project. Within a MIDP project, you can create multiple project 
  configurations that customize your MIDlet for different types of mobile devices. 
</p>
<p>The IDE builds its project infrastructure directly on top of Apache Ant, the
  leading build tool for Java applications. The IDE stores all of the information
  about your project in an Ant script, a properties file, and a few XML configuration
  files. This means that you can build and run your projects outside of the IDE
exactly the same as inside the IDE.</p>
<p>When a project is created, the IDE: </p>
<ul>
  <li>Creates a source tree you can examine in the Projects or Files views.</li>
  <li>Sets the emulator platform for the project. </li>
  <li>Sets the project run and compile-time classpaths.</li>
  <li>Creates a build script that contains actions for running, compiling, debugging,
    and building Javadoc.</li>
</ul>
<p>The MIDP project structure is similar to that of standard NetBeans <a href="nbdocs://org.netbeans.modules.java.helpset/org/netbeans/modules/java/helpset/docs/project/proj_about.html">projects</a>. 
  There are differences, however, in the <code>build</code> and <code>dist</code> 
  folders to accommodate the MIDP build process. </p>
<p><strong>Logical View</strong></p>
<p>The logical view of the project, shown in the Projects window, provides a hierarchy 
  of sources and resources which reflects the type of project and its contents. 
</p>
<p>By right-clicking on the project node, you can choose the following Mobility-specific 
  menu items: </p>
<ul>
  <li><strong>Batch Build.</strong> Opens a dialog that lets you select multiple 
    configurations. The IDE then builds a distribution JAR for each configuration 
    you select. </li>
  <li><strong>Batch Clean &amp; Build.</strong> Opens a dialog that lets you select 
    multiple configurations. The IDE then cleans and builds a distribution JAR 
    file for each configuration you select. </li>
  <li><strong>Batch Clean.</strong> Opens a dialog that lets you select multiple 
    configurations. The IDE then cleans the build files for each configuration 
    you select. </li>
  <li><strong>Batch Deploy.</strong> Opens a dialog that lets you select multiple 
    configurations. The IDE then <a href="../deploy/about_deployment.html">deploys</a> 
    your application according to the deployment properties set in each configuration 
    you select.</li>
  <li><strong>Run With.</strong> Opens the Quick Project Run dialog. In this dialog, 
    you can select a device &quot;on the fly&quot; on which to test your application. 
    The IDE runs your application on the selected platform, but does not build 
    the project or create a distribution JAR for that platform. </li>
</ul>
<p>The Source Packages node encapsulates all the Java packages of the project. 
  Right-clicking on the Source Package node and choosing New lets you add new 
  <a href="proj_templates.html">file templates</a> to your application. </p>
<p>The Resources node encapsulates all resources and libraries of the active configuration. 
  The IDE notifies you through a note on the node if the active configuration 
  inherits resources and libraries from <code>DefaultConfiguration</code>. </p>
<p>Right-clicking the Resources node enables you to add Project, JARs, folders, 
  and libraries as resources for your application. You can not add or remove inherited 
  resources. </p>
<p>Right-clicking on the Project Configurations node opens the Add Configuration 
  wizard, which enables you to create new configurations for your project. </p>
<p><strong>Files View</strong></p>
<p>When a project is created, the following folders are created under <code>build</code> 
  (shown in the Files window): </p>
<ul>
  <li><code>compiled.</code> Contains all compiled classes.</li>
  <li><code>preprocessed.</code> Holds the source files after they are preprocessed. 
    The files will differ from the original source files if you are using project 
    configurations. </li>
  <li><code>obfuscated.</code> Holds the obfuscated versions of the class files.</li>
  <li><code>preverified</code>. Holds the preverified versions of the class files. 
    These files are packaged into the distribution JAR of your project. </li>
  <li><code>preverifysrc</code>.Versions of the source files before they are preverified.</li>
</ul>
<dl>
  <dt> <a name="seealso">See Also</a>:</dt>
  <dd><a href="proj_quickref.html">Java ME MIDP Project Tasks: Quick Reference</a></dd>
  <dd><a href="proj_working.html">Working with Java ME MIDP Projects</a><br>
    <a href="proj_templates.html">Java ME MIDP Templates</a><br>
    <a href="../configuration/config_about.html">About Project Configurations</a></dd>
</dl>
<hr>
<small><a href="../getstarted/credits.html">Legal Notices</a></small> 
<table cellpadding="50" border="0">
  <tr>
    <td width="263">&nbsp;</td>
  </tr>
</table>
</body>
</html>

